/*
 * $Id: DragAndDrop.js,v 1.14 2005/02/23 06:23:35 shanmugampl Exp $
 */

var dragobject = null;
var tx;
var ty;
var draging = false;
var ie5 = document.all != null && document.getElementsByTagName != null;

/**
 * The view in which the mouseover action has occured.
 */
var enabledView = null;

/**
 *
 */
var draggedViewId = null;
 
function endDrag(event) {
	if(draging){
		var currElement = null;
		if (browser_ie){
			currElement=window.event.srcElement;
		}
		else if (browser_nn4 || browser_nn6){
			currElement=event.target;
		}
//		document.getElementById('help').className = 'hide';
		if(enabledView  == null){
			resetDragData();
			return;
		}
		var elemId = currElement.id;
		if(elemId.indexOf('_ev') < 0 && elemId.indexOf('_indicator') < 0){
			disableViewSelection();
			resetDragData();
			return;
		}

		var draggedViewObj = document.getElementById(draggedViewId);
		var draggedViewName  = draggedViewObj.getAttribute("viewName");
		var draggedViewTitle  = draggedViewObj.getAttribute("title");
		if(draggedViewId.indexOf('LV') >= 0 || draggedViewId.indexOf('RV') >= 0){
			if(insertView(draggedViewObj, enabledView)){
				draggedViewObj.className = 'viewSelected';
			}
		}
		if(draggedViewId.indexOf('_ev') >= 0){
			changeView(draggedViewObj, enabledView);
		}
		resetDragData();
	}
}

function resetDragData() {
	draging = false;
	dragobject = null;
	enabledView = null;
	draggedViewId = null;
	document.getElementById('movableDiv').className = 'hide';
}

function drag(e) {
	if (browser_ie)
		document.selection.empty();
	else if (browser_nn4 || browser_nn6)
		window.getSelection().removeAllRanges(); 

	if (dragobject) {
		if( browser_nn4 || browser_nn6 ) {				
			if (e.pageX >= 0 && e.pageY >= 0) {
				dragobject.style.left = e.pageX;
				dragobject.style.top = e.pageY+1;
			}
		}
		else {
			if (window.event.clientX >= 0 && window.event.clientY >= 0) {
				dragobject.style.left = window.event.clientX;
				dragobject.style.top = window.event.clientY + 1;
			}
		}
	}
}

document.onmouseup = endDrag;
document.onmousemove = drag;
/**
 *
 */
function startDrag(event, id){
	draggedViewId = id;
	var currObj = document.getElementById(id);
	if(currObj.className.indexOf('viewNotSelected') < 0 && currObj.className.indexOf('wkContent') < 0){
		return;
	}
	var data = currObj.innerHTML;
	var obj = document.getElementById("movableDiv");
	document.getElementById('movableDivContent').setAttribute('height', currObj.getAttribute('height')+'px');
	document.getElementById('movableDivContent').setAttribute('width', currObj.getAttribute('width')+'px');
	document.getElementById('movableDivContent').innerHTML = currObj.getAttribute('title');
	obj.style.left = findPosX(getObj(id));
	obj.style.top = findPosY(getObj(id)) - 10;
	obj.className = 'show';
	dragobject = obj;
	draging = true;
	if( browser_nn4 || browser_nn6 ) {				
		ty = event.pageY - findPosY(dragobject);
		tx = event.pageX - findPosX(dragobject);
	}
	else {
		ty = window.event.clientY - findPosY(dragobject);
		tx = window.event.clientX - findPosX(dragobject);
	}
}
/**
 *
 */
function enableSelection(object){
	if(draging){
		var id = object.id;
		//		if((enabledView != null) && (enabledView != id)){
		//			document.getElementById(enabledView+"_dv").className = 'dummyView';
		//		}
		enabledView = id;

		if(id.indexOf("_evl") >= 0){
			object.className = 'emptyCellHover';
		}
		else if(id.indexOf("_ev") >= 0){
			document.getElementById(id+"_dv").className = 'emptyCellHover';
		}
	}
}

/**
 *
 */
function disableSelection(object){
	if(draging){
		var id = object.id;
		if(id.indexOf("_evl") >= 0){
			object.className = 'emptyCell';
		}
		else if(id.indexOf("_ev") >= 0){
			document.getElementById(id+"_dv").className = 'emptyCell';
		}
		enabledView = null;
	}
}
